package com.rf.psychological.scale.resultBusiness.scaleResult;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zsy
 * @description:饮酒问卷
 * @date 2021/7/20 15:55
 */
public class ADSScale extends BaseScale{

    public ADSScale(JSONArray jsonArray, JSONObject resultJson) {
        super(jsonArray, resultJson);
    }

    public  JSONObject scaleCalculate() throws Exception {

        // 自定义路径使用
        /*String fileUrl;
        //设置文件路径
        if(OSUtil.isLinux()){
            fileUrl = "./scalesDll/ADSScale.dll";
        }else{
            fileUrl = "D:\\softWare\\ideaWorkspace\\psychological\\src\\main\\resources\\scalesDll\\ADSScale.dll";
        }
        //System.load("D:\\softWare\\ideaWorkspace\\psychological\\src\\main\\resources\\scalesDll\\FESCVSCALE.dll");
        System.load(fileUrl);
        System.out.println("JSONArray:"+jsonArray);
        System.out.println("JSONObject:"+resultJson);
        XScale xScale = new XScale(jsonArray,resultJson);
        String result = xScale.ADSScale(jsonArray.toString(), resultJson.toString());

        //解决排序问题
        LinkedHashMap<String, Object> jsonMap = JSON.parseObject(result,LinkedHashMap.class, Feature.OrderedField);
        JSONObject jsonObject = new JSONObject(true);
        jsonObject.putAll(jsonMap);
        System.out.println("jsonObjectc:"+jsonObject);
        return jsonObject;*/


        //得分
        int score = 0;
        for (int i = 0; i < jsonArray.size(); i++) {
            JSONObject jsonObject1 = jsonArray.getJSONObject(i);
            if (i == 0){
                if (jsonObject1.getString("checkItems").equals("喝醉了喝得烂醉")) {
                    score += 1;
                }
            }else if (i == 1){
                if (jsonObject1.getString("checkItems").equals("是的")) {
                    score += 1;
                }
            }else if (i == 2 || i == 3 || i == 4 || i == 5 || i == 10 || i ==11){
                if (jsonObject1.getString("checkItems").equals("有时")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("几乎每次都有")) {
                    score += 2;
                }
            }else if (i == 6 || i == 7){
                if (jsonObject1.getString("checkItems").equals("仅有一次")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("一次以上")) {
                    score += 2;
                }
            }else if (i == 8){
                if (jsonObject1.getString("checkItems").equals("是的")) {
                    score += 1;
                }
            }else if (i == 9){
                if (jsonObject1.getString("checkItems").equals("有时")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("经常")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("几乎每次喝酒以后")) {
                    score += 3;
                }
            }else if (i == 12 || i == 13){
                if (jsonObject1.getString("checkItems").equals("一次")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("一次以上")) {
                    score += 2;
                }
            }else if (i == 14 || i == 16 || i == 17 || i == 23 || i == 24){
                if (jsonObject1.getString("checkItems").equals("是")) {
                    score += 1;
                }
            }else if (i == 15){
                if (jsonObject1.getString("checkItems").equals("是但仅有几小时是")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("有一两天是")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("有好几天")) {
                    score += 3;
                }
            }else if (i == 18 || i == 20){
                if (jsonObject1.getString("checkItems").equals("仅一次")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("一次以上")) {
                    score += 2;
                }
            }else if (i == 19 || i == 21){
                if (jsonObject1.getString("checkItems").equals("一两次")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("经常有")) {
                    score += 2;
                }
            }else if (i == 22){
                if (jsonObject1.getString("checkItems").equals("有，丧失记忆的时间超过一小时")) {
                    score += 1;
                } else if (jsonObject1.getString("checkItems").equals("有，丧失记忆的时间超过几个小时")) {
                    score += 2;
                } else if (jsonObject1.getString("checkItems").equals("有，丧失记忆的时间一天以上")) {
                    score += 3;
                }
            }
        }

        Map<String, String> resultMap1 = new LinkedHashMap<>();
        resultMap1.put("总分", String.valueOf(score));
        resultJson.put("总分", String.valueOf(score));
        if (score == 0){
            resultMap1.put("结论", "无酒依赖的表现");
            resultJson.put("总分结论", "无酒依赖的表现");
        }else if (score >= 1 && score <= 13){
            resultMap1.put("结论", "对酒依赖的水平较低，主要表现为心理的依赖，而非躯体的。此类受试者多愿限制饮酒量，而非欲断酒");
            resultJson.put("总分结论", "对酒依赖的水平较低，主要表现为心理的依赖，而非躯体的。此类受试者多愿限制饮酒量，而非欲断酒");
        }else if (score >= 14 && score <= 21){
            resultMap1.put("结论", "中等水平的酒依赖，可能有与饮酒有关的社会心理问题，但以心理依赖为主，继续发展可能出现躯体依赖，戒断症状。受试者可能愿意减少饮酒量，而非彻底戒酒");
            resultJson.put("总分结论", "中等水平的酒依赖，可能有与饮酒有关的社会心理问题，但以心理依赖为主，继续发展可能出现躯体依赖，戒断症状。受试者可能愿意减少饮酒量，而非彻底戒酒");
        }else if (score >= 22 && score <= 30){
            resultMap1.put("结论", "酒依赖发展到相当的程度。可能出现了躯体依赖可能存在与饮酒有关的躯体障碍和社会心理间题，告诉受试者应该认真考虑彻底戒酒，这是唯一解决间题的办法");
            resultJson.put("总分结论", "酒依赖发展到相当的程度。可能出现了躯体依赖可能存在与饮酒有关的躯体障碍和社会心理间题，告诉受试者应该认真考虑彻底戒酒，这是唯一解决间题的办法");
        }else if (score >= 31 && score <= 47){
            resultMap1.put("结论", "酒依赖发展到了严重的程度，躯体依赖可能性很大，并可能出现了与饮酒有关的躯体障碍，如肝脏疾病，应告诫病人彻底戒酒是唯一的治疗方案");
            resultJson.put("总分结论", "酒依赖发展到了严重的程度，躯体依赖可能性很大，并可能出现了与饮酒有关的躯体障碍，如肝脏疾病，应告诫病人彻底戒酒是唯一的治疗方案");
        }

        List<Map<String,String>> resultMapList = new ArrayList<>();
        resultMapList.add(resultMap1);

        JSONObject returnJson = new JSONObject(true);
        returnJson.put("resultMapList",resultMapList);
        returnJson.put("resultJson",resultJson);

        return returnJson;
    }
}
